package com.nosum.common.annotation;

import com.nosum.common.enums.OperateEnum;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;


/**
 * 操作日志.
 *
 * @author Young
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
public @interface OperateLog {

    /**
     * 模块名
     *
     * @return 模块名称
     */
    String module();

    /**
     * 操作编号
     *
     * @return 操作编号
     */
    OperateEnum code() default OperateEnum.GET_POSTS_DEFAULT;
}