package com.nosum.common.base.domain;

import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.StrUtil;
import com.nosum.common.constant.Constants;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Data
@Accessors(chain = true)
public class PageInfo<T> {

    private long page = Constants.DEFAULT_PAGE_INDEX;
    private long size = Constants.DEFAULT_PAGE_SIZE;
    private Long total;

    private List<T> record;

    public static <T> PageInfo<T> withRequest() {
        HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
        String page = request.getParameter("page");
        String size = request.getParameter("size");
        if (StrUtil.isNotBlank(page) && StrUtil.isNotBlank(size)) {
            return new PageInfo().setPage(NumberUtil.parseInt(page)).setSize(NumberUtil.parseInt(size));
        }
        return new PageInfo();
    }
}
