package com.nosum.deliver.auth.service;

import com.nosum.common.base.domain.Result;
import com.nosum.common.base.service.BaseService;
import com.nosum.deliver.auth.domain.po.AuthUser;
import com.nosum.deliver.auth.domain.vo.AuthUserVO;

public interface AuthUserService extends BaseService<AuthUser> {

    /**
     * 获取用户信息
     */
    Result getUserInfo(AuthUserVO authUserVO);

    /**
     * 获取作者信息
     */
    Result getMasterUserInfo();

    /**
     * 获取用户列表
     */
    Result getUserList(AuthUserVO authUserVO);

    /**
     * 退出登录
     */
    Result logout();

    /**
     * 更新管理员个人资料
     */
    Result updateAdmin(AuthUserVO authUserVO);

    /**
     * 更新个人资料
     */
    Result updateUser(AuthUserVO authUserVO);

    /**
     * 更新用户状态
     */
    Result saveAuthUserStatus(AuthUserVO authUserVO);

    /**
     * 删除用户
     */
    Result deleteUsers(Long id);

    /**
     * 获取管理员头像
     */
    String getAvatar();
}
