package com.nosum.deliver.category.dao;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.nosum.deliver.category.domain.po.Category;
import com.nosum.deliver.category.domain.vo.CategoryVO;
import com.nosum.common.base.dao.BaseDao;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 * @author sumbytes
 * @since 2019-08-28
 */
public interface CategoryDao extends BaseDao<Category> {

    /**
     * 查询一个分类有多少篇文章
     * @return
     */
    List<CategoryVO> selectCategoryPostsTotal();
    IPage<CategoryVO> selectStatistics(Page page, @Param(Constants.WRAPPER) Wrapper<CategoryVO> queryWrapper);

    IPage<Category> selectListPage(@Param("page") Page page, @Param("condition") CategoryVO categoryVO);
}
