package com.nosum.deliver.monitor.controller;

import com.alibaba.fastjson.JSONObject;
import com.nosum.common.annotation.LoginRequired;
import com.nosum.common.base.domain.Result;
import com.nosum.system.enums.RoleEnum;
import org.hyperic.sigar.Mem;
import org.hyperic.sigar.Sigar;
import org.hyperic.sigar.SigarException;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.nosum.deliver.monitor.util.RuntimeUtil;

import java.math.BigDecimal;

@RestController
@RequestMapping("/monitor")
public class MonitorController {

    @GetMapping("/system/v1/get")
    @LoginRequired(role = RoleEnum.ADMIN)
    public Result getSystem() {
        return RuntimeUtil.getProperty();
    }

    @GetMapping("/memory/v1/get")
    @LoginRequired(role = RoleEnum.ADMIN)
    public Result getMemory() {
        JSONObject obj = new JSONObject();
        // 内存总量
        obj.put("total", 0);
        // 当前内存使用量
        obj.put("used", 0);
        // 当前内存剩余量
        obj.put("free", 0);
        // 使用率
        obj.put("usedRatio", 0);
        return Result.createWithModel(obj);
    }

    @GetMapping("/cpu/v1/get")
    @LoginRequired(role = RoleEnum.ADMIN)
    public Result getCpu() {
        return RuntimeUtil.getCpu();
    }

    @GetMapping("/file/v1/get")
    @LoginRequired(role = RoleEnum.ADMIN)
    public Result getFile() {
        return RuntimeUtil.getFile();
    }

    @GetMapping("/net/v1/get")
    @LoginRequired(role = RoleEnum.ADMIN)
    public Result getNet() {
        return RuntimeUtil.getNet();
    }

    @GetMapping("/ethernet/v1/get")
    @LoginRequired(role = RoleEnum.ADMIN)
    public Result getEthernet() {
        return RuntimeUtil.getEthernet();
    }
}
