package com.nosum.deliver.posts.service;

import com.nosum.common.base.domain.Result;
import com.nosum.common.base.service.BaseService;
import com.nosum.deliver.posts.domain.po.Posts;
import com.nosum.deliver.posts.domain.vo.PostsVO;

public interface PostsService extends BaseService<Posts> {

    /**
     * 保存文章
     */
    Result savePosts(PostsVO postsVO);

    /**
     * 编辑文章
     */
    Result updatePosts(PostsVO postsVO);

    /**
     * 删除文章
     */
    Result deletePosts(Long id);

    /**
     * 查询单个文章
     */
    Result getPosts(Long id);

    /**
     * 查询文章的列表
     */
    Result<PostsVO> getPostsList(PostsVO postsVO);

    /**
     * 博客搬家 抓取其他平台我的博客
     */
    Result getPlatformArticle(PostsVO postsVO);

    /**
     * 按照时间归档文章数量
     */
    Result<PostsVO> getArchiveTotalByDateList(PostsVO postsVO);

    /**
     * 按照年维度查询带有文章标题的归档列表
     */
    Result getArchiveGroupYearList(PostsVO postsVO);

    /**
     * 更新文章的状态
     */
    Result updatePostsStatus(PostsVO postsVO);


    /**
     *  查询热门文章
     */
    Result getHotPostsList(PostsVO postsVO);

    Result getPostStatistics();


}
